# ****************************************************************************
# Surgeweb javascript - User interface handler functions
# Note: sw.js is the primary surgeweb javascript code
# ----------------------------------------------------------------------------
#  These functions are designed to be called from multipe user interface elements etc 
# ****************************************************************************

function swcmd(action,e,input)
{
#	alert("requested to:"+action+" the messages="+sel.join(','));
	if (action.length==0) return;
	if (action=='sw_delete') 	do_delete();
	else if (action=='sw_read')		do_mark_read();
	else if (action=='sw_unread')	do_mark_unread();
	else if (action=='sw_reply_all')	do_reply_all();
	else if (action=='sw_redirect')	do_redirect();
	else if (action=='sw_forward_attach') 	do_forward_attach();
	else if (action=='sw_forward') 	do_forward();
	else if (action=='sw_reply') 	do_reply();
	else if (action=='sw_cache') 	do_cache();
	else if (action=='sw_compose') 	do_compose(e);
	else if (action=='sw_edit') 	do_edit();
	else if (action=='sw_print') 	do_print();
	else if (action=='sw_copy') 	do_copy_show(e,input);
	else if (action=='sw_move') 	move_menu(e,'more_actions',input);
	else if (action=='sw_spam') 	do_spam();
	else if (action=='sw_notspam') 	do_notspam();
	else if (action=='sw_label') 	labels_menu(e,'more_actions',input);
	else if (action=='sw_download_msg') 	do_download_msg();
	else alert('Sorry  don\'t know how to '+action+' yet');
}

function do_reply()
{
	var e=window.event;
	var sel=find_sel();
	if (!check_sel(sel,'replied to')) return;
	var jmsg=sel_to_jmsg(sel,'reply');
	show_edit(jmsg,e);
}

function do_mark_unread()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_set_flags(sel,'clear','seen',function(node){class_add(node,'msg_unread')})
	do_select('none');
}
function do_mark_read()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_set_flags(sel,'set','seen',function(node){class_remove(node,'msg_unread')})
	do_select('none');
}
function do_mark_flagged(sel)
{
	if (!sel) sel=find_sel();
	if (!sel) return;
	ajax_set_flags(sel,'set','flagged',function(node){class_add(row_to_star(node),'star_sel')})
}
function do_mark_unflagged(sel)
{
	if (!sel) sel=find_sel();
	if (!sel) return;
	ajax_set_flags(sel,'clear','flagged',function(node){class_remove(row_to_star(node),'star_sel')})
}



function check_sel(sel,type)
{
	if (!sel) return false;
	if (sel.length>1) alert('Only one message at a time can be '+type+'. First selected message is getting used.');
	return true;
}

function do_forward(){
	var e=window.event;
	var sel=find_sel();
	if (!sel) return false;
	var jmsg=sel_to_jmsg(sel,'forward')
	show_edit(jmsg,e);
}
function do_reply_all(){
	var e=window.event;
	var sel=find_sel();
	if (!check_sel(sel,'replied to')) return;
	var jmsg=sel_to_jmsg(sel,'replyall')
	show_edit(jmsg,e);
}
function do_redirect(){
	var e=window.event;
	var sel=find_sel();
	if (!check_sel(sel,'redirected')) return;
	var jmsg=sel_to_jmsg(sel,'redirect')
	show_edit(jmsg,e);
}
function do_forward_attach(){
	var e=window.event;
	var sel=find_sel();
	if (!sel) return false;
	var jmsg=sel_to_jmsg(sel,'forward_attach')
	jmsg.msg_html='';
	show_edit(jmsg,e);
}
function do_edit()
{
	var e=window.event;
	var sel=find_sel();
	if (!sel) return;
	var jmsg=sel_to_jmsg(sel,'edit')
	show_edit(jmsg,e);
}

function do_notspam()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_spam_rating(sel,'notspam',function(node){class_remove(node,'foo')})
	do_select('none');
}

# Used for testing currently :-)
function do_spam()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_spam_rating(sel,'spam',function(node){class_remove(node,'foo')})
	do_select('none');
}

function show_raw(mid)
{
	dbg("show_raw");
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+xescape(sw.fld_id)+'&msg_id='+mid+'&part_id=0');
}
function show_text(mid,pid)
{
	dbg("show_html");
#	headers now say text/plain instead of text/html so no web encoding should be required
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+xescape(sw.fld_id)+'&msg_id='+mid+'&part_id='+pid);
}
function show_html(mid,pid)
{
	dbg("show_html");
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+xescape(sw.fld_id)+'&msg_id='+mid+'&part_id='+pid+'&process=simple_wash');
}
function show_img(pid)
{
#	QQQ turn cursor_mid into parameter

	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+xescape(sw.fld_id)+'&msg_id='+cursor_mid+'&part_id='+pid);
}

function do_customise()
{
	x_alert("Sorry, menu customise not implemented just yet.");
}

function do_na(txt)
{
	x_alert("Sorry, "+txt+" not implemented yet");
}

function do_folder_manage()
{
	sndReq('cmd=show&page=~folders.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
	});
}

function do_compose(e)
{
	dbg('do_compose');
	show_edit(compose_jmsg([]),e);
	return stopEvent(e);
}

function edit_discard()
{
	if(!sw.active.unsaved){
		edit_discard_real();
	}else{
		x_confirm("The message you have been writing will be lost. Are you sure?",function(n){
			if (!n)return;
			edit_discard_real();
		});
	}
}
function edit_discard_real()
{
	if (sw.is_popup) {
		sw.closing=true;
		window.close();
		return;
	}
	ie_fixfocus()
	window_manager_killpane(sw.active);
	set_status("Message discarded","success");
	window_manager_restore();
}
function msg_list_dblclick(e){
	var t=target(e);
	var row=find_message_row(t);
	var valid_row=row_to_sel(row);
	if (!valid_row) return;
	var mid=valid_row.id.substring(4);
	if (e.shiftKey || e.ctrlKey){
		select_none_fast();
		msglist_select(mid);	
	}
	if (pref.mode=='web'){
		preview_msg(mid);
	}
	show_msg(mid,e);
	if (pref.mode=='app'&&pref.preview=='none' || pref.mode=='web'){
		mark_read(mid);
	}	
}
# QQSEL CLICK
function msg_list_click(e){
	// select more than one if we have to...
	var t=target(e);
	var tag=t.tagName.toLowerCase();
	var row=find_message_row(t);
	var web = pref.mode=='web' && tag=="a";
	var mid;

	// Handle the clicking of select boxes...
	if (tag=="input"){
		var sel=t;
		if (e.shiftKey && shift_sel_start){
			complete_selection(row,sel.checked?true:false)
		}else{
			if(cursor_row_valid(cursor_row) && !row_to_sel(cursor_row).checked) row_unselect(cursor_row);
			node=sel_to_row(t);
			if (sel.checked)
				row_select(node,true);
			else
				row_unselect(node);
		}
		cursor_mid=sel_to_mid(sel);
#		cursor_row=node;
	} else {
		// click anywhere in a row
		var td=find_message_td(t);
		if(td==row.childNodes[1]) return;
		var valid_sel=row_to_sel(row);
		if (!valid_sel) return;
		if (td==row.childNodes[0]) {
		 	mid=sel_to_mid(valid_sel);
		 	sel=make_sel(sw.fld_id,mid);
		 	if(!class_contains(td.firstChild,'star_sel'))
				do_mark_flagged(sel);
			else
				do_mark_unflagged(sel);
			return;
		}
		
		var unselect;
		if (!(e.shiftKey || e.ctrlKey) || web)
			select_none_fast();
		unselect=valid_sel.checked;
		if (!web){
			if (e.shiftKey && shift_sel_start){
				complete_selection(row,row.sel==true?false:true)
			}else if (e.ctrlKey){
				if (unselect){
					if(cursor_row) row_unselect(cursor_row);
					row_unselect(row);
				}else{
					if(cursor_row) row_select(cursor_row,true);
					row_select(row,true);
				}
			}
		}
		mid=sel_to_mid(valid_sel);
		if (!unselect){
			msglist_select(mid,true);	
		}
		if (pref.mode=='app'&&pref.preview!='none'){
			preview_msg(mid);
		}
		if (web){
			dbg("*** new handler :-) showing msg");
			show_msg(mid,e);		// This depends on separate retrieval of actual message content
			mark_read(mid);
		}
	}
	shift_sel_start=row;
	touch(8);
	if (tag!="input") 
		return false;
}

var last_retr_mid, last_retr_time;
function retrieve_msg(fld,mid,cb,extra,nostatus)
{
	var now=new Date().getTime();
	if(last_retr_mid==mid && last_retr_time>now-1000) {
		dbg("IGNORING retrieve_msg request - too soon, mid="+mid);
		return;
	}
	dbg("retrieve_msg request mid="+mid);
	last_retr_time=now;
	last_retr_mid=mid;
	if(!extra) extra='';

	sndReq('cmd=show&page=~msg.js&msg_id='+mid+"&fld_id="+xescape(fld)+extra, function(chan){
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status('Failed to retrieve message : '+success_string,'warning');
			if(cb) cb(false);
			return;
		}else{
			if(!nostatus) set_status();
		}

		var success=actionReqJsStat(chan);
		cache_add(cache_id(sw.fid,mid), amsg);
		if(cb) cb(true);
	});
}

function assign_destination_html(destination,mid,txt)
{
	var el=dge(destination);
	el.innerHTML=txt;
	el.scrollTop=0;	
	if(destination=='message_preview')
		preview_mid=mid;
}

var seen_timer;
var amsg,allmsgs;
var preview_mid;
# Asynchronously retrieve message (and do any requested completion action - only used for preview)
# This should really start using the actual retrieve_msg function
function preview_msg(mid,cb,nostatus)
{
	if (seen_timer) clearTimeout(seen_timer);

	var destination;
	if (pref.preview=='none')
		return;

	destination='message_preview';

	var fld=sw.fld_id;

	dbg("preview message id=="+mid+" display 2");

	var xid=cache_id(sw.fid,mid);
#	All getting a bit messy - should try and tidy this up
	cursor_mid=(sw.xfolder?xid:just_mid(mid));
	if(sw_cache && sw_cache[xid]){
		dbg("attempting to load message id="+mid+" from cache");
		var qmsg=sw_cache[xid];
		assign_destination_html(destination,mid,html_from_qmsg(qmsg));
		special_processing(destination,qmsg);	

		set_status();
		mark_read(mid);
	}else{
		if (destination) set_loading(destination);
		
		retrieve_msg(sw.fld_id,mid, function(success){
			if (destination) doneloading();
			if (!success) return;

			var qmsg=sw_cache[xid];
			assign_destination_html(destination,mid,html_from_qmsg(qmsg));
			special_processing(destination,qmsg);	
			mark_read(mid);
		},nostatus);	
	}
}

function special_processing(destination,qmsg)
{
	if(destination=='message_preview'){
		var o=dge('msg_to');
		if(!class_contains(o.parentNode,'hidden_in_preview') && !class_contains(dge('msg_cc').parentNode,'hidden') && qmsg.data.nrcpts_to<=2)
			class_add(o.parentNode, 'float_left');
	}
}


function do_logout()
{
	sw.closing=true;
	var f=document.main;
	f.submit();
}


function do_delete(force)
{

	if (sw.is_popup){
		sw_win.do_delete2(sw.mid);
		window.close();
		return;
	}

	var sel=find_sel(true);
	if (!sel) return;

	if (!pref['confirm_delete'] || force || sel.length==1 ){
		do_delete_step2(sel);
		return;
	}
	x_confirm('Deleting '+sel.length+' messages. Are you sure?',function(n){
		if (!n)return;
		do_delete_step2(sel);
	});
}
function do_delete_step2(sel)
{
	set_status("Deleting...","info");
	do_select('none');
	ajax_delete(sel);
	message_done_action(sel);
}

function do_options()
{
	node=sw.active;
	if (node && node.className=="compose")
		window_manager_minimise(node);

	sndReq('cmd=show&page=~options.htm', function(chan){
#		// Same in manage_folders
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status(success_string,'warning');
			return false;
		}
		node=actionReqSethtml(http.responseText,'utility');
		if (global_auth_error){
			global_auth_error=false;
			window_manager_restore();
		}		
	});
}

function options_discard()
{
	ie_fixfocus();
	window_manager_killpane(sw.active);
	set_status("Changes to options discarded","success");
	window_manager_restore();	
}

function options_save()
{
	var fake_form, real_form, pane, recache;
	ie_fixfocus();
	real_form=document.options;
	var el=dge('eframe_sig');
	if(el.viewMode==2) toggleMode(undefined,dge('etbar_sig'));
	var o=el.contentWindow;
	var newsig=o.document.body.innerHTML;
	real_form.pref_signature.value=newsig.replace(/\n/g,'').replace(/\r/g,'');
	if(newsig.length>1000){
		alert('Your signature is '+newsig.length+' characters long and currently cannot be longer than approx 970 characters - signature will be truncated, posibly resulting in odd behaviour.\n\nnote: html tag characters are part of character count');
	}

	var btns=toolbar_buttons_get();

#	Send everything to the server
	fake_form='cmd=save_options,show&page=~result.js';
#	fake_form+='&to='+real_form.to.value;

	fake_form+='&pref_no_fancy_rcpt='+real_form.pref_no_fancy_rcpt.checked;
	fake_form+='&pref_no_filtermenus='+real_form.pref_no_filtermenus.checked;
	fake_form+='&pref_no_replycolor='+real_form.pref_no_replycolor.checked;
	fake_form+='&pref_no_auto_timezone='+real_form.pref_no_auto_timezone.checked;
	fake_form+='&pref_nocache='+real_form.pref_nocache.checked;
	fake_form+='&pref_nocompress='+real_form.pref_nocompress.checked;
	fake_form+='&pref_sticky_menus='+real_form.pref_sticky_menus.checked;
	fake_form+='&pref_reply='+encodeURIComponent(real_form.pref_reply.value);
	fake_form+='&pref_timezone='+real_form.pref_timezone.value;
	fake_form+='&pref_imap_refresh='+real_form.pref_imap_refresh.checked;
	fake_form+='&pref_signature='+xescape(real_form.pref_signature.value);
	fake_form+='&pref_cur_signature='+real_form.pref_cur_signature.value;

	fake_form+='&pref_date_format='+real_form.pref_date_format.value;
	fake_form+='&pref_time_format='+real_form.pref_time_format.value;
	fake_form+='&pref_message_done_action='+real_form.pref_message_done_action.value;
	fake_form+='&pref_message_done_action2='+real_form.pref_message_done_action2.value;
	fake_form+='&pref_allow_images='+real_form.pref_allow_images.value;
	fake_form+='&pref_sounds='+real_form.pref_sounds.value;
	fake_form+='&pref_edit_mode='+real_form.pref_edit_mode.value;
	fake_form+='&pref_send_mode='+real_form.pref_send_mode.value;
	fake_form+='&pref_noautoadd='+real_form.pref_noautoadd.checked;
	fake_form+='&pref_custom='+real_form.pref_custom.value;

#	This line needs to go
#	fake_form+='&pref_layout='+real_form.pref_layout.value;

	fake_form+='&pref_mode='+real_form.pref_mode.value;
	fake_form+='&pref_preview='+radio_value(real_form.pref_preview);
	fake_form+='&pref_windows='+radio_value(real_form.pref_windows);

	fake_form+='&pref_devt_mode='+real_form.pref_devt_mode.checked;
	fake_form+='&pref_nocheck='+real_form.pref_nocheck.checked;
	fake_form+='&pref_unimplemented='+real_form.pref_unimplemented.checked;

	fake_form+='&pref_colour='+real_form.pref_colour.value;
	fake_form+='&pref_image_resize='+real_form.pref_image_resize.value;

#	fake_form+='&pref_search_default='+real_form.pref_search_default.value;
	fake_form+='&pref_spellcheck_language='+real_form.pref_spellcheck_language.value;

	fake_form+='&pref_toolbar_buttons='+btns;

	for(var i=1;i<=6;i++){
		fake_form+='&pref_folder_move_'+i+'='+xescape(real_form['pref_folder_move_'+i].value);
	}

	pane=sw.active;
	set_status("Saving options...","info");
	sndReqPost(fake_form, function(chan){
		var success=actionReqJsStat(chan);			
		

		// Do success fail check
		set_status('Options saved. Now <a href="#" onclick="do_reload()">reload page</a> if required.',"success");		

#	Update relevant local settings
		signature['default']=real_form.pref_signature.value;
		pref_reply=real_form.pref_reply.value;

		pref.message_done_action=real_form.pref_message_done_action.value;
		pref.message_done_action2=real_form.pref_message_done_action2.value;

		pref.cur_signature=real_form.pref_cur_signature.value;
		pref.sounds=real_form.pref_sounds.value;
		pref.mode=real_form.pref_mode.value
		pref.preview=real_form.pref_preview.value
		pref.windows=real_form.pref_windows.value
		pref.sticky_menus=real_form.pref_sticky_menus.value
		pref.no_fancy_rcpt=real_form.pref_no_fancy_rcpt.value
		pref.no_replycolor=real_form.pref_no_replycolor.value

		pref.no_filtermenus=real_form.pref_no_filtermenus.value
#		pref.search_default=real_form.pref_search_default.value
		if(pref.allow_images!=real_form.pref_allow_images.value){
			pref.allow_images=real_form.pref_allow_images.value;
			cache_clear();
		}

		if(pref.nocache!=real_form.pref_nocache.checked || !done_cache){
			pref.nocache=real_form.pref_nocache.checked;
			if (pref.nocache){
				cache_clear();
			}else{
				var fld=sw.fld_id;
				if(fld=='INBOX'){
					var msgs=find_msgs();
					if (msgs.length==0) return;
					setTimeout(function(){		
						done_cache=true;
						ajax_cache_messages(msgs);	
					},400);
				}
			}
		}
		if(pref.toolbar_buttons!=btns){
			pref.toolbar_buttons=btns;
			toolbar_buttons_customise(btns);
		}
		window_manager_killpane(sw.active);
#		panel_remove(pane);
		window_manager_restore();	
	});	
}

# QQSEL
function do_select(type)
{
	var nodes=sw.msgs_panelist.getElementsByTagName("tr");
	if (type=='all'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden'))
				row_select(node,true);
		}
	}else if(type=='none'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			row_unselect(node);
		};
		fastselect_hitcount=0;
	}else if(type=='new'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden')){
				if (class_contains(node,'msg_unread'))
					row_select(node,true);
				else
					row_unselect(node);
 			}
		};
	}else if(type=='read'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden'))
				if (class_contains(node,'msg_unread'))
					row_unselect(node);
				else
					row_select(node,true);
		};
	}else if(type=='replied'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden'))
				if (class_contains(node,'msg_replied'))
					row_select(node,true);
				else
					row_unselect(node);
		};
	}else if(type=='flagged'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden'))
				if (!class_contains(row_to_star(node),'star_sel'))
					row_unselect(node);
				else
					row_select(node,true);
		};
	}

	select_mailbox_all(type);
}
function select_mailbox_all(type)
{
	if(sw.nav_count==sw.nav_total)	return;
	var ex=dge('list_extra');
	if(type=='all'){
		if (sw.nav_total>0 && !sw.search_input.valid){
			class_remove(ex,'hidden');
			class_remove(ex,'all_sel');
			ex.innerHTML='All '+sw.nav_count+' messages on this page selected. <a href="#" onclick="select_mailbox_all(\'folder_all\')">Select all '+sw.nav_total+' in '+sw.fld_id+' folder</a>';
		}
		sw.sel_all=false;
	}else if(type=='folder_all'){
		class_remove(ex,'hidden')
		class_add(ex,'all_sel');
		ex.innerHTML='All '+sw.nav_total+' messages in '+sw.fld_id+' folder selected. <a href="#" onclick="do_select(\'none\')">Clear selection</a>';
		sw.sel_all=true;
	}else{
		class_add(ex,'hidden')
		sw.sel_all=false;
	}
}
function deselect_mailbox_all()
{
	var ex=dge('list_extra');
	class_add(ex,'hidden')
	sw.sel_all=false;
}


function clear_indexes()
{
	dbg('Clearing indexes serverside');
	x_confirm('This will log you out are you sure?',function(n){
		if (!n) return;
		sndReq('cmd=clear_indexes,show&page=~result.js', function(chan){
			dbg('response came back, unknown status');
			do_logout();
		});
	});
}

function manage_folders(e)
{
	sndReq('cmd=show&page=~folders.htm', function(chan){
#		// same in do_options factor out into common code
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status(success_string,'warning');
			return false;
		}
		node=actionReqSethtml(chan.responseText,'utility');
		if (global_auth_error){
			global_auth_error=false;
			window_manager_restore();
		}		
	});
	stopEvent(e);
	return false;
}

function manage_labels(e)
{
	sndReq('cmd=show&page=~labels.htm', function(chan){
#		// same in do_options factor out into common code
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status(success_string,'warning');
			return false;
		}
		node=actionReqSethtml(chan.responseText,'utility');
		if (global_auth_error){
			global_auth_error=false;
			window_manager_restore();
		}		
	});
	stopEvent(e);
	return false;
}

function index_dump()
{
	sndReq('cmd=index_dump&page=~folders.htm&fld_id='+xescape(sw.fld_id), function(chan){
//		node=actionReqSethtml(http.responseText,'utility');
	});
}
function folders_done()
{
	window_manager_minimise(sw.active);
	window_manager_restore();	
}

//qqqtab
function tab_close(id){
	var tabtokill=document.getElementById(id);
	tabtokill.closing=true;
	if(tabtokill.node_ref==sw.active){
		window_manager_killpane(tabtokill.node_ref);
		window_manager_restore();
	}else{
		window_manager_killpane(tabtokill.node_ref);
	}
	
#	Make sure we remove the additional nodes too??	

# 	does not work FF/Saf (does in IE) so use tabtokill.closing instead
#	return stopEvent();		
}

function do_save_draft(auto,cb)
{

	var node,win,src_win;
	if(sw.is_popup){
		node=sw.active;
		node.sw_win = sw_win;
		node.is_popup=true;
		win=sw_win;// Pass the send through the parent frame if we can
		if(sw.run_spellcheck_once) win.sw.run_spellcheck_once=true;
	}else{
		win=window;
		node=sw.active;
	}
	src_win=window;
	
	spellcheck_markup_removeall(!auto&&!sw.run_spellcheck_once);	
	win.popup_spellcheck=window;
	
	var jmsg=jmsg_update(node);
	win.ajax_save_draft(jmsg,undefined,function(jsmsg){
		var o=src_win.document.getElementById('compose_info');
		if (o) o.innerHTML='Draft '+(auto?'auto ':'')+'saved at '+time_str();
		if (cb) cb();
	});

	if(autosave_timer){
		clearTimeout(autosave_timer);
		autosave_timer=null;
	}
}

function sel_and_action(id)
{
	setTimeout(function(){
		var sel=find_sel(true);
		if (!sel) return;
		if (sel.join(',')==id.join(',')){
			do_select('none');			
			message_done_action(sel);
		}
	},150);
}

function do_send_move(e)	// cf ajax_send, do_move, 
{
	var node=sw.active;
	if(sw.is_popup){
		node.sw_win = sw_win;
		node.is_popup=true;
		var jmsg=jmsg_update(node);
		sw_win.ajax_send(jmsg,true,undefined,e.shiftKey==true);
		sw_win.sel_and_action(jmsg.sel_mids);
		sw_win.focus();
		sw.closing=true;
		window.close();
	}else{
		var jmsg=jmsg_update(node);
		ajax_send(jmsg,true,undefined,e.shiftKey==true);
		sel_and_action(jmsg.sel_mids);
		ie_fixfocus()
	}
}
function do_send()
{
	var node=sw.active;
	if(sw.is_popup){
		node=sw.active;
		node.sw_win = sw_win;
		node.is_popup=true;
		if(!main_window_check(node)) return;
		var jmsg=jmsg_update(node);
		sw_win.ajax_send(jmsg);
		sw_win.sel_and_action(jmsg.sel_mids);
		sw_win.focus();
		sw.closing=true;
		window.close();
	}else{
		var jmsg=jmsg_update(sw.active);
		ajax_send(jmsg);
		sel_and_action(jmsg.sel_mids);
		ie_fixfocus()
	}
}

#var app_warning=true;
function do_old(type)
{
	var cmd;

	if (type!="mail" && type!="contacts" && !pref.hide_integration_warning){
		alert("Calendar, Photos and Blogs are not yet fully integrated\ninto the interface but instead displayed within an iframe.\n\nAt some stage in the near future integration will be improved.");
		ajax_pref_save('pref_hide_integration_warning=true');
		pref.hide_integration_warning=true;
	}

	if (type=='mail'){
		if (sw.active && sw.active.id=='iframe_panel'){
			window_manager_killpane(sw.active);
			window_manager_restore();	
		}
	}else if (type=='blogs'){
#		var extra="vhost=mybox&webmail=true&bgcolor=#FFFFFF&tdcolor=#eeeeff&thcolor=#D6D6CE&border=0&background_image=cust_panel_background&user=marijn@mybox&id=29640"
#		var cmd=backend+"cgi/user.cgi?utoken="+utoken+"&cmd=blogs_list&"+extra;			
		var cmd=cgibase+'cmd=doauto_login&product=usercgi&type=blogs&sid='+sid;
	}else if (type=='photos'){
#		var cmd=backend+'surgeplus/web?utoken='+utoken+'&cmd=sp_file_sharing&hide_menu=true&fname=Pictures/';
		var cmd=cgibase+'cmd=doauto_login&product=surgeplus&type=photos&sid='+sid+'&id='+(new Date()).getTime();
	}else if (type=='filestore'){
		var cmd=cgibase+'cmd=doauto_login&product=surgeplus&type=filestore&sid='+sid+'&id='+(new Date()).getTime();
	}else if (type=='calendar'){
#		var cmd=backend+'surgeplus/web?utoken='+utoken+'&cmd=sp_calendar&hide_menu=true';
		var cmd=cgibase+'cmd=doauto_login&product=surgeplus&type=calendar&sid='+sid+'&id='+(new Date()).getTime();
	}else if (type=='contacts'){
		return contacts_mgt_sw();
	}
	if (!cmd) return true;


	sndReq('cmd=show&page=~iframe.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');		
		el=document.getElementById('an_iframe');
		el.src=cmd;		
	});
	return true;
}

function contacts_mgt_sw()
{
	if (!sw.abooks){
		x_alert('Contact information has not yet completed downloading.')
		return false;
	}

	sndReq('cmd=show&page=~contacts.htm', function(chan){
#		// Same in manage_folders
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status(success_string,'warning');
			return false;
		}
		node=actionReqSethtml(http.responseText,'utility');
		if (global_auth_error){
			global_auth_error=false;
			window_manager_restore();
		}		
	});
	return true;
}	
function contacts_mgt_sp()
{
	var cmd='/surgeplus/web?utoken='+utoken+'&cmd=sp_address_book&hide_menu=true';
	sndReq('cmd=show&page=~iframe.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');		
		el=document.getElementById('an_iframe');
		el.src=cmd;		
	});
}

function allow_images(type,jmsg)
{
	if(!jmsg) jmsg=sw.active.jmsg;
#debugger;
	if(sw.is_popup){
		sw_win.allow_images(type,jmsg);
		show_msg_step2_popup();
		return;	
	}
	var mid,fld;
	if(jmsg){
		fld_id=jmsg.fld_id;
		fid=jmsg.fid;
		mid=jmsg.cache_mid;
		jmsg_reset(jmsg);
	}else{
		fld_id=sw.fld_id;
		fid=sw.fid;
		mid=cursor_mid;
	}

	var xid=cache_id(fid,mid);
	if (sw_cache && sw_cache[xid]) 
		cache_remove(xid,true);

	retrieve_msg(sw.fld_id,mid,function(){
			if(class_contains(sw.active,'message')&&sw.active.jmsg.cache_mid==mid)
				show_msg_step2_inline(jmsg,sw.active.instance);
			if(preview_mid==mid)
				preview_msg(mid);
		},'&allow_images='+type);
}

# mostly copy of above function see if we can combine
function show_all(type,jmsg)
{
	if(!jmsg) jmsg=sw.active.jmsg;
	if(sw.is_popup){
		sw_win.show_all(type,jmsg);
		show_msg_step2_popup();
		return;	
	}
	var mid,fld;
	if(jmsg){
		fld_id=jmsg.fld_id;
		fid=jmsg.fid;
		mid=jmsg.cache_mid;
		jmsg_reset(jmsg);
	}else{
		fld_id=sw.fld_id;
		fid=sw.fid;
		mid=cursor_mid;
	}

	var xid=cache_id(fid,mid);
	if (sw_cache && sw_cache[xid]) 
		cache_remove(xid,true);

	retrieve_msg(sw.fld_id,mid,function(){
			if(class_contains(sw.active,'message')&&sw.active.jmsg.cache_mid==mid)
				show_msg_step2_inline(jmsg,sw.active.instance);
			if(preview_mid==mid)
				preview_msg(mid);
		},(type=='attach'?'&all_attach=true':'&all_rcpts=true'));
}

function app_menu(type,o,display_only)
{
	if (!display_only) 
		if(do_old(type)==false)
			return false;
	if(sw.cur_app_menu)
		class_remove(sw.cur_app_menu,"sel");
	var el=document.getElementById("app_"+type);
	if (el){
		class_add(el,"sel");
		sw.cur_app_menu=el;
	}
	if (o) {
		var txt=o.firstChild.innerHTML;
		if (txt=='Contacts') txt='Contact Groups'
		if (type=='mail' && sw.quota && (pref.always_show_quota || sw.quota.pct>80)) 
			txt='<span class="quota_info'+(sw.quota.pct>80?' quota_warn':'')+'">'+sw.quota.pct+'% of '+sw.quota.limit+' </span>'+txt;
		dge('lpanel_hdr_text').innerHTML=txt;
		var q1=dge('lpanel_body');
		if(q1.active_pane) 
			class_add(q1.active_pane,'hidden');
		var q2=dge('lpanel_'+type);
		if (!q2) {
			q2=new_anchor('div','<div style="padding:5px">More "'+txt+'" functionality will be added here as integration is improved. For now, see main panel to the right.</div>',q1);
			q2.id='lpanel_'+type;
		}
		class_remove(q2,'hidden');
		q1.active_pane=q2;
	}
	if (type=='mail'){
		fldmsg_display(enFLD);
	}
}
function app_menu_mail()
{
	if(sw.cur_app_menu  && sw.cur_app_menu.id!='app_mail')	
		app_menu('mail',dge('app_menu_mail'),true);
}


function textMode()
{
	alert("sorry switching to plain text not implemented yet");
}


function do_move(e,id){
	if (!e) e = window.event;
	var t = target(e);
	if (t.tagName.toLowerCase()=='a'){		
		if (class_contains(t,'fake')){
			fld_expand(e);
			stopEvent(e)
			return;
		}		
		do_move_hide(id);
		do_move_actual(t.fname)
	}
}

function do_move_actual(fld,unlabel)
{
	var sel=find_sel();
	if (!sel) return;
	if (!fld) return;
	set_move_status(sel,fld);
	dbg('do_move - selection ['+sel+']');
	ajax_msg_move(sel,fld,false,unlabel);
	do_select('none');
	message_done_action(sel);
}
function do_move_hide(id)
{
	var el=document.getElementById(id);
	class_add(el,'hidden');
}

function do_copy_show(e,input)
{
	do_folder_menu_setup(e,'folder_menu');
#	do_generic_menu_setup('folder','folder_menu',(e&&e.shiftKey));
	do_menu_show('folder_menu', e, true, function(result,fld_id,create,del_menu){
		var sel=find_sel();
		if (!sel) return;

		filtermenu_search_clear(dge('folder_menu').menu_list);
		msglist_select(sel[sel.length-1]);

		if(result!='ok'){
			input.value='';
			return;	
		}
		set_status("Copying...","info");
		ajax_msg_copy(sel,fld_id,create,del_menu);
		input.value='';
	});
}
# cf do_label_show, do_copy_show
function do_move_show(e,more_actions)
{
	var options={};
	if(more_actions) options.t=more_actions;
	do_folder_menu_setup(e,'folder_menu');
#	do_generic_menu_setup('folder','folder_menu',(e&&e.shiftKey));
	do_menu_show('folder_menu',e,true,	function(result,fld_id,create,del_menu){
		var sel=find_sel(true);
		if (!sel) return;

		filtermenu_search_clear(dge('folder_menu').menu_list);
		msglist_select(sel[sel.length-1]);

		if(more_actions) more_actions.value='';
		if(result!='ok'){
			return;	
		}
		if(sw.is_popup){
			sw_win.do_move_popup(sw.mid,sw.fld_id,fld_id,create,del_menu);
			window.close();
			return;
		}
		set_move_status(sel,fld_id);
		dbg('do_move - selection ['+sel+']');
		ajax_msg_move(sel,fld_id,create,del_menu);
		do_select('none');
		message_done_action(sel);
	},options);
}



function do_move_popup(mid,src,dst,create,del_menu)
{
	var msgs=[mid];
	set_move_status(msgs,dst);
	msgs.fld_id=src;
	ajax_msg_move(msgs,dst,create,del_menu);
}

function refresh(e){
	var t=target(e);
	var el=ancestor_by_class(t,'full_cursor');
	var row=el.parentNode;
	var fld=row.getAttribute('fld_id');	

	F(fld,undefined,undefined,true);
	stopEvent(e);
}

# Display folder with particular fld_id
function F(fld_id, type, start, refresh, noreset, opt)
{	
	fldmsg_display(enFLD);
	menu_custom_fld(type);

	select_mailbox_all('none');
	set_loading("messages_list");
	fastselect_hitcount=0;
	if(!noreset) search_init(undefined,pref.search_type);
	var extra=(start==undefined)?"":"&start="+start;
	extra+=(refresh==true)?"&refresh=true":"";
	extra+='&sort='+sw.sort_type+'&rev='+sw.sort_rev;
	var o=sw.search_input;
	if(o.valid){
		if(sw.search_type=='body') extra+='&search_type=imap&search='+xescape(sw.search_input.value);
		if(sw.search_type=='folder') extra+='&search='+xescape(sw.search_input.value);
	}
	if(opt && opt.refresh_allmsgs) extra+='&refresh_allmsgs=true';
	extra+='&tz='+(-((new Date()).getTimezoneOffset())/60*100);
	var cmd='cmd=show&page=~msgs.js&fld_id='+xescape(fld_id)+extra;
	sndReq(cmd, function(chan){
		doneloading();
		set_status();
		success = actionReqJs(chan);
		if (global_auth_error){
			global_auth_error=false;
			global_request_reissue=cmd;
		}
		if (!success){
			if (!success_string) success_string="Communication error - server not reachable";
			set_status('Failed to retrieve messages : '+success_string,'warning');
			return;
		}
		msgdnd_init();
		if(o.valid && (sw.search_type=='body' || sw.search_type=='folder')) {
			sw.search_input.focus();
		}
			
	});	
	switch_selfld(fld_id,opt);
	if(type){
		sw.fld_type=type;
		menu_arrange(type);
	}
	touch(7);
	stop_shift();
}

function F2(fld_id, type, jmsg, type)
{	
	var extra='&history=true';
	var qmsg=sw_cache[cache_id(sw.fid,jmsg.cache_mid)];
		
	if(type=='thread')
		extra+='&search='+xescape('subject:'+qmsg.data['subject']+' folders:recent');
	else
		extra+='&search='+xescape('email:'+qmsg.data['from']+' folders:recent');
	
	extra+='&tz='+(-((new Date()).getTimezoneOffset())/60*100);
	var cmd='cmd=show&page=~msgs.js&fld_id='+xescape(jmsg.fld_id)+extra;
	sndReq(cmd, function(chan){
		doneloading();
		success = actionReqJs(chan);
		if (global_auth_error){
			global_auth_error=false;
			global_request_reissue=cmd;
		}
		if (!success){
			success_string="Communication error - server not reachable";
			set_status('Failed to retrieve message : '+success_string,'warning');
			return;
		}else{
			set_status();
		}
	});	
}

function L(id)
{
	if(id.indexOf(' ')!=-1) id='"'+id+'"';
	search_init('label:'+id+' folders:recent');
	F(sw.fld_id,0,0,false,true);
}

function msg_previous(msgs,mid)
{
	var last=msgs[0];//-1;//;
	for (var i=0;i<msgs.length; i++) {
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	if(i==msgs.length && msgs[i]!=mid)
		last=msgs[0];
	return last;
}
function msg_next(msgs,mid)
{
	var last=msgs[msgs.length-1];//-1;//msgs[msgs.length-1];
	for (var i=msgs.length-1;i>=0; i--) {
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	return last
}
function msg_prev_valid(msgs,mid)
{
	var last=msgs[0];
	for (var i=0;i<msgs.length; i++) {
	  if (class_contains(sel_to_row(dge('sel_'+msgs[i])),'action_pending'))
	  	continue;
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	return last;
}
function msg_next_valid(msgs,mid)
{
	var last=msgs[msgs.length-1];
	for (var i=msgs.length-1;i; i--) {
	  if (class_contains(sel_to_row(dge('sel_'+msgs[i])),'action_pending'))
	  	continue;
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	return last
}


function show_prev(mid,nofocus)
{
	var jmsg=sw.active.jmsg;
	if(sw.is_popup){
		if(!compare_folders(jmsg.fld_id,sw_win.sw.fld_id)) return;
		sw.active.innerHTML="Loading...";
		sw_win.jmsg_reset(jmsg);
#		Switch to using just find_next + retrieve message??
		jmsg.cache_mid=sw_win.show_prev_preview(mid,true);
		show_msg_step2_popup();
	} else if(class_contains(sw.active,'message')){
		if(!compare_folders(jmsg.fld_id,sw.fld_id)) return;
		jmsg_reset(jmsg);
		jmsg.cache_mid=show_prev_preview(mid,true);
		show_msg_step2_inline(jmsg,sw.active.instance);
	}else{
		show_prev_preview(mid,nofocus);
	}
}
function show_prev_preview(mid,nofocus)
{	
	select_none_fast();
	var xmid=show_prev_real(sw.multiple?mid:just_mid(mid),true);
	show_soon(xmid,undefined,nofocus);
	return xmid;
}

function show_prev_real(mid,do_end,check_pending)
{
	var msgs=find_msgs();
	var xnew=msg_previous(msgs,mid);
	dbg("show_prev msg="+mid+" prevmsg="+xnew);
	if (xnew==-1){
		mailbox_end=true;
		if (do_end)
			Mx("You have reached the end of the mailbox");
		return mid;
	}
	if(check_pending){
		if(class_contains(sel_to_row(dge('sel_'+xnew)),'action_pending')){
			xnew=msg_next_valid(msgs,mid);
		}
	}
	
	return xnew;
}

function show_next(mid,nofocus)
{
	var jmsg=sw.active.jmsg;
	if(sw.is_popup){
		if(!compare_folders(jmsg.fld_id,sw_win.sw.fld_id)) return;
		sw.active.innerHTML="Loading...";
		sw_win.jmsg_reset(jmsg);
#		Switch to using just find_next + retrieve message??
		jmsg.cache_mid=sw_win.show_next_preview(mid,true);
		show_msg_step2_popup();
	} else if(class_contains(sw.active,'message')){
		if(!compare_folders(jmsg.fld_id,sw.fld_id)) return;
		jmsg_reset(jmsg);
		jmsg.cache_mid=show_next_preview(mid,true);
		show_msg_step2_inline(jmsg,sw.active.instance);
	}else{
		show_next_preview(mid,nofocus);
	}
}
function show_next_preview(mid,nofocus)
{	
	select_none_fast();
	var xmid=show_next_real(sw.multiple?mid:just_mid(mid),true);
	show_soon(xmid,undefined,nofocus);
	return xmid;
}

function show_next_real(mid,do_end,check_pending)
{
#debugger;
	var msgs=find_msgs();
	var xnew=msg_next(msgs,mid);
	dbg("show_next msg="+mid+" nextmsg="+xnew);
	if (xnew==-1){
		mailbox_end=true;
		if (do_end)
			Mx("You have reached the end of the mailbox");
		return mid;
	}
	if(check_pending){
		if(class_contains(sel_to_row(dge('sel_'+xnew)),'action_pending')){
			xnew=msg_prev_valid(msgs,mid);
		}
	}
	return xnew;
}
var showsoon_timer;
# Update message list selection ('cursor') and try download the mesage "soon"
function show_soon(mid,tick,nofocus,nostatus)
{
#	// Can get here from 1) Arrow keys on list page, but may already have opened a message => ignore
#						 2) Prev next arrows in preview pane => show it in preview
#						 4) Prev next arrows in popup/tabbed/inline message => show it in msg display (also in preview)
#						 5) Various message_done_action configurations => action it...
	msglist_select(mid,tick,nofocus);	
	if(showsoon_timer) clearTimeout(showsoon_timer);	
	showsoon_timer=setTimeout(function(){ 
		show_preview(mid,undefined,undefined,nofocus,nostatus);
		showsoon_timer=null; 
	},150);
}


function message_done_action(sel)
{
#	if (sw.util.fldmsg_current==enMSG){
#		or select next message
	var x=pref.message_done_action;
	var x2=pref.message_done_action2;
	var fwd=true;
#	if(!class_contains(sw.active,'fldmsg')){

	if (sw.active!=sw.msgs_pane){
		if(pref.windows=='inline' && x2!='list'){
			x=x2;
		}else{
			if(pref.windows=='tabbed')
				window_manager_killpane(sw.active);
			layout_fldmsg(enFLD);
		}
	}
	if (x=='none') {
		no_msg_sel();
		return;
	}
#	Select next message in list or in message	
	if (x=='prev') fwd=false;
#	if (shiftkey()) fwd=!fwd;
	if (fwd) 
		show_soon(show_next_real(sel[sel.length-1],false),undefined,undefined,true);
	else
		show_soon(show_prev_real(sel[0],false),undefined,undefined,true);
}
function nav(item){
	F(sw.fld_id,sw.fld_type,item,false,true);	
}


function popout_msg(mid)
{
	show_msg(mid,null,'popup');
	if (sw.active!=sw.msgs_pane){
		if(pref.windows=='inline'){
			layout_fldmsg(enFLD);
		}else{
			window_manager_killpane(sw.active);
			window_manager_restore();
		}
	}	
}

function popin_msg(mid)
{
	sw_win.show_msg(mid,null,'inline');
	window.close();
}

function minimise_edit()
{
	dbg('minimise message clicked');
	
	// if not a message displayed then return for now
	if (pref.windows!='tabbed'){
		if (!confirm("To miminise a message tabbed mode needs to be enabled. Enable tabs mode interface?"))
			return;
			
		pref.windows='tabbed';
		ajax_pref_save('pref_windows='+pref.windows);
		class_remove(document.getElementById('switcher'),'hidden');
	}
	window_manager_minimise(sw.active);	
}

function popout_edit()
{
	var jmsg=jmsg_update(sw.active);
	jmsg.not_new = true;
	show_edit(jmsg,null,'popup');
	if (sw.active!=sw.msgs_pane){
		if(pref.windows=='inline'){
			layout_fldmsg(enFLD);
		}else{
			window_manager_killpane(sw.active);
			window_manager_restore();
		}
	}
}
function popin_edit()
{
	var node=sw.active;
	if(!main_window_check(node)) return;
	var jmsg=jmsg_update(node);
	if (sw_win.pref.windows!='tabbed' && class_contains(sw_win.sw.active,'compose')){
		if (!confirm("You are already editing a message in the main pane. Enable tabs mode interface to continue?"))
			return;
		sw_win.pref.windows='tabbed';
		sw_win.ajax_pref_save('pref_windows='+sw_win.pref.windows);
		sw_win.class_remove(sw_win.document.getElementById('switcher'),'hidden');

	}
	jmsg.from_popout=true;
	jmsg.not_new = true;
	sw_win.show_edit(jmsg,null,'inline');
	sw.closing=true;
	window.close();	
}
function do_reload(interface_ex)
{
	sw.closing=true;
	if (!interface_ex) interface_ex='ajax';
	document.reload.sid.value=sid;
	document.reload.fld_id.value=sw.fld_id;
	document.reload.interface_ex.value=interface_ex;
	document.reload.submit()
}
function live_refresh(){
	do_reload();
}

function show_cc(type,node,nosave)
{
	var base=node?node:sw.active;

	dbg('show_cc '+type);

	var o=base.field_cc;
	if (type=='bcc')
		o=base.field_bcc;
	else if (type=='extra')
		o=base.field_priority;
	
	var po=ancestor_by_class(o,'compose_hdr_row');
	
	if(class_contains(po,'hidden'))	{
		class_remove(po,'hidden');
	}else{
		class_add(po,'hidden');
		o.value='';
	}

	if(sw.is_popup){
		popup_resize();
	}else{
		do_resize_real();
		stop_shift();
	}

 	if(!nosave) save_sticky();
 	
#	FUDGE to make sure buttons are correctly redrawn in IE
	force_redraw(po.parentNode)
}
function check_folder_name(name)
{
	if (name.indexOf('/')==-1 && name.indexOf('\\')==-1) return true;
	x_alert("Invalid folder name - characters used reserved by imap server");
	return false;
}
function do_folder_create()
{
	var new_name;
	var el=dge('folder_new_under');
	var new_name=(el.value.length>0)?el.value+'/':'';
	el=dge('folder_new_name');
	if(!check_folder_name(el.value)) return;
	new_name+=el.value;
	sndReq('cmd=folder_create,show&new_name='+xescape(new_name)+'&page=~folders.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
	});
}
function folder_create_cx()
{	
	x_prompt('Create new folder under "'+(sw.menu_fld?sw.menu_fld:'More Folders')+'" :','newname',function(val){
		if(!val || !check_folder_name(val)) return;
		var new_name=(sw.menu_fld!=null?sw.menu_fld+'/':'')+val;
		sndReq('cmd=folder_create,show&new_name='+xescape(new_name)+'&page=~folders.htm', function(chan){
			node=actionReqSethtml(chan.responseText,'utility');
		});
	});
}
function delete_folder(name)
{
	x_confirm('This will permanently delete all mail in the folder "'+name+'". Are you sure?',function(n){
		if (!n)return;
		sndReq('cmd=folder_delete,show&delete_name='+xescape(name)+'&page=~folders.htm', function(chan){
			node=actionReqSethtml(chan.responseText,'utility');
		});
	});
}


function rename_folder(name,short_name)
{
	var page='~folders.htm';
	var html=true;

	if(!name){
		name=sw.menu_fld;
		short_name=sw.menu_short;
#		page='~result.js';
#		html=false;
	}

	x_prompt('Rename the folder "'+short_name+'" to:',short_name,function(val){
		if(!val || !check_folder_name(val)) return;
		var folders='&folder_rename_src='+xescape(name)+'&folder_rename_dst='+xescape(val);
		dbg('renaming '+short_name+' to '+val)
		sndReq('cmd=folder_rename,show&'+folders+'&page='+page, function(chan){
			if(html){ 
				node=actionReqSethtml(chan.responseText,'utility');
			}else{
#				alert(sw.fld_id+':'+sw.menu_fld)
#				success=actionReqJsStat(chan);
#				if(sw.fld_id==sw.menu_fld) 
#				alert(sw.fld_id+':'+sw.menu_fld)
#					F('INBOX',0,0,false,true);
			}
		});
	});
}

function move_folder(name,short_name)
{		
	x_custom_dlg('Move the folder "'+short_name+'" to:',
				 '<select name="folder_move_dst">'+dge('folder_new_under').innerHTML+'</select>',
				 function(btn){
		val=dge("folder_move_dst").value;
		if(!btn || !val) return;
		var folders='&folder_move_src='+name+'&folder_move_dst='+val;
		dbg('renaming '+name+' to '+val)
		sndReq('cmd=folder_move,show&'+folders+'&page=~folders.htm', function(chan){
			node=actionReqSethtml(chan.responseText,'utility');
		});
	});
}

function do_cache()
{
	var sel=find_sel();
	if (!sel) return;
	if(sel.sel_all) {
		select_mailbox_all('disable');
		alert('Sorry - cannot cache whole mailbox, only caching messages on this page');
	}
	ajax_cache_messages(sel)
}

# IE does not support indexOf on arrays so do it ourselves
function my_indexOf(obj,id){
	if(obj.indexOf) 
		return obj.indexOf(id);

	for(var i=0; i<obj.length; i++){
		if(obj[i]==id){
			return i;
		}
	}
	return -1;
}

function do_purge(e){
	var t=target(e);
	var el=ancestor_by_class(t,'full_cursor');
	var row=el.parentNode;
	var fld_id=row.getAttribute('fld_id');	
	
	ajax_purge(fld_id);
	if(sw.fld_id==fld_id){
		no_msgs_fld();
		no_msg_sel();
		update_unread_many({'fld_id':fld_id,unread:0});
		navigator_set(0,0,0,"")
	}
	stop_shift();
	stopEvent(e);
}


function do_print()
{
	var sel=find_sel();
	if (!check_sel(sel,'printed')) return;
	open_popup('cmd=show&page=print.htm&sid='+sid+'&fld_id='+xescape(sw.fld_id)+'&msg_id='+sel[0]);
}

function contacts_close()
{
	app_menu('mail',dge('app_menu_mail'));
}

function contacts_new()
{
	cm_contact_edit();
}
function contacts_import()
{
//	x_custom_dlg2('select file to upload in custom dialog with an iframe (including other import flags)',function(){
//		x_alert('importing contacts... with result.');
//		return false;
//	});

	x_custom_dlg2('Select file to upload ',
				 '<iframe id="dlg_iframe" src="" style="width:100%;height:'+px(300)+';background:#ECE9D8;" frameborder="0"></iframe>',
		function(btn){
#			x_custom_dlg2 messes up the standard dialog so much that it is no longer easily reusable so remove completely
			dlg_reset();
#			if(!btn) return;
			cm_contacts_refresh();
		},
		function(){
			var ch=ClientHeight();
			var cw=ClientWidth();
			var o=dge('dlg_win').style;
			o.left=px(0.5*cw-200);
			o.top=px(0.5*ch-200);
			o.width = px(400);	
			
			var xdoc=dge("dlg_iframe").contentWindow.document;

			xdoc.open();
			xdoc.write('<html><head><body style="background:#ECE9D8;">');
			xdoc.write('Select file to import <br>note: must be outlook csv file, vcf file support will be added soon...<br><form action="||cgi||" method="POST" enctype="multipart/form-data">File: <input type="file" name="attach"><br>');
			xdoc.write('<br>to addressbook: '+abks_select("abook"));
			xdoc.write('<br><br><input name="add_unrecognised" type="checkbox">Add any unrecognised data as part of the comment<br><input name="cmd_contact_import" type="submit" value="Import">');
			xdoc.write('</form></body></html>')
			xdoc.close();
		});
}

function abks_select(book)
{	
	var txt;
	var abks=sw.abooks_write;
	for(var i=0;i<abks.length;i++){
		txt+='<option value="'+abks[i]+'">'+abks[i]+'</option>';
	}
	return '<select name="'+book+'">'+txt+'</select>';
}
function contacts_new_shared(name,short_name)
{	

	x_custom_dlg('Create new contact in the addressbook:',
				 abks_select("contact_abk_select"),
				 function(btn){
		var val=dge("contact_abk_select").value;
		if(!btn || !val) return;
		abook_new=val;
		cm_contact_edit();
	});
}
var abook_new="User";


function contacts_copy_shared(name,short_name)
{	
	if(!sw.curr_contact){
		x_alert("Select a contact to copy first.")
		return;
	}
	x_custom_dlg('Copy contact <b><i>'+c_name(sw.curr_contact)+'</i></b> to the addressbook:',
				 abks_select("contact_abk_select"),
				 function(btn){
		var val=dge("contact_abk_select").value;
		if(!btn || !val) return;
		contact_copy_one(sw.curr_contact,val);
	});
}




function do_contact_email(id)
{
	var e=window.event;
	c=address_book.data[id];
	var rcpt=c_name_co(c)+' <'+c_email(c)+'>';
	var jmsg=compose_jmsg([rcpt]);
	if(pref.windows!='popup' && !e.shiftKey){
		app_menu_mail();
	}
	show_edit(jmsg,e);
}
function do_contact_email2(id,email)
{
	var e=window.event;
	c=address_book.data[id];
	var rcpt=c_name_co(c)+' <'+email+'>'
	var jmsg=compose_jmsg([rcpt]);

	if(pref.windows!='popup'){
		app_menu_mail();
	}
	show_edit(jmsg,e);
}
function do_new_email(name,address)
{
	var e=window.event;
	var rcpt=name+' <'+address+'>';
	var jmsg=compose_jmsg([rcpt]);
	if(pref.windows!='popup' && !(e&&e.shiftKey)){
		app_menu_mail();
	}
	show_edit(jmsg,e);
}


function do_sort(txt)
{
	if (txt!=sw.sort_type){
		sw.sort_rev=(txt=='date'||txt=='size')?true:false;
	} else {
		sw.sort_rev=!sw.sort_rev;
	}
	dge('sort_menu_txt').innerHTML=(sw.sort_rev?'reverse ':'')+txt;
	sw.sort_type=txt;
	F(sw.fld_id,0,false,false,true);
}

function do_move_done(e)
{
	var unlabel=(e.shiftKey==true) ;
	do_move_actual('Done',unlabel);
}
function do_download_msg()
{
	var sel=find_sel();
#	if (!check_sel(sel,'printed')) return;
	var xx=cgibase+'cmd=msgpart&sid='+sid+'&fld_id='+xescape(sw.fld_id)+'&msg_id='+sel[0]+'&part_id=0&attachment=true';
	window.location.href=xx;
	return;

	setTimeout("window.open(xx,'Download')",5000);
	return;
	var q=dge("qwerty")
	q.href=xx;
	dispatch_click(q);
}

function do_display(txt)
{
	var search;
	dge('display_menu_txt').innerHTML=txt;
	
	if(txt=='day'||txt=='week') search='date:'+txt;
	if(txt=='unread') search='-flag:seen';
	if(txt=='unreplied') search='-flag:replied';
	if(txt=='read') search='flag:seen';
	if(txt=='replied') search='flag:replied';
	if(txt=='flagged') search='flag:star';

	search_init(search);

	F(sw.fld_id,0,false,false,true);
}

# Revamp of search... 
function search_init(value,type,location,opt)
{	
#	return;
	if (!type) type='folder';
	if (value){
		if(value.indexOf('folders:recent')!=-1) location='recent'; 
		if(value.indexOf('folders:all')!=-1) location='all'; 
	}
	var id=0;
	if(type=='folder') id=1;
	if(type=='body') id=2;
	var el=dge('pg_menu_search').childNodes[id];
	do_stype(el,type,value,location,opt);
}
# QQSRCH	do_stype
function do_stype_mnu(el,txt)
{
	do_stype(el,txt);
	pref.search_type=txt;
	ajax_pref_save("pref_search_type="+txt);
	sw.search_input.value='';
	search_info(sw.search_type,'single');
	class_remove(sw.search_limit,"hidden");	
}
# Iniatise from scratch any kind of search...
function do_stype(el,txt,search,location)
{
#	if(txt=='all'){
#		alert('IMAP search not yet implemented');
#		return;
#	}
#debugger;
	
	if(!search && txt!='quick') msglist_unsearch(true);
	sw.search_type=txt;
	if(el){
#		Select menu tickmark
		var o=el.parentNode;
		for (var i=0;i<o.childNodes.length;i++){
			var cc=child_by_class(o.childNodes[i],'menu_tick');
			if (cc && cc.className) class_remove(cc,'selected');
		}
#		if(el==o.childNodes[2]) el=o.childNodes[0];
		class_add(child_by_class(el,'menu_tick'),'selected');
		
		var icon='search_icon';
		if(txt=='folder') icon+='2';
		if(txt=='body') icon+='3';
		
		class_set(dge('search_bar_icon'),icon);
#		Setup search field as blank or with required search params
		if(search) {
			search_field_set(search,location);
			try{
				sw.search_input.focus();
			}catch(e){}
		}else{
			search_field_set();
		}
	}
}	

function search_keyup(e)
{
	if (!e) e = window.event;
	dbg("doing search keyup");

	var t = target(e);
	if (e.keyCode==27){
		msglist_unsearch();
#		search_init();
		dge("mnu_reply").focus();
	}
	switch(e.keyCode){
#		ESC
		case 27:
			return;
#		Enter
		case 13:
			if(sw.search_type=='quick'){
				var v=t.value;
				if (sw.nav_count!=sw.nav_total || e.ctrlKey || v.indexOf(':')!=-1 || v.indexOf('-')!=-1 || v.indexOf('"')!=-1){
					do_search_folders(e.ctrlKey?'recent':undefined);
				}
				return;
			}else if (sw.search_type=='folder'){
				if (e.ctrlKey)
					do_search_folders('single','body');
			}
			dge('display_menu_txt').innerHTML='custom search';
			var opt={};
			if(sw.seach_location!='single') opt.multiple=true;
			action_search(sw.fld_id,0,false,false,true,opt)
			return;
		default:
			if(sw.search_type=='quick'){
				apply_quick_search(t.value);
#				class_remove(sw.search_limit,"hidden");	
			}	
			return;
	
	}
}
function search_field_set(search,location)
{
	if(search==undefined){
		var o=sw.search_input;
		if(sw.search_type=='quick'){
			o.value="Quick search...";
		}else if(sw.search_type=='folder'){
			o.value="Search...";
			dge('display_menu_txt').innerHTML='all';
		}else if(sw.search_type=='body'){
			o.value="Body search...";
		}
		o.style.color='#777';
		o.valid=false;
		class_add(sw.search_limit,"hidden");	
	}else{
		var o=sw.search_input;
		o.value=(search?search:"");
		o.valid=true;
		o.style.color='black';
		deselect_mailbox_all();
		if (!location) location=pref.search_default;
		search_info(sw.search_type,location);
		class_remove(sw.search_limit,"hidden");	
	}
}
#	QQSRCH msglist_unsearch
function msglist_unsearch(simple)
{
	sw.search_input.value='';
	if(sw.search_type=='folder'){
		if(simple) return;
		F(sw.fld_id,0,false,false,true);
	}else{
		var count=apply_quick_search('');
		if (count>0){
			class_remove(sw.search_limit,"hidden");	
		}else{
			class_add(sw.search_limit,"hidden");	
		}		
	}
}
# QQSRCH	do_search_folders
function do_search_folders(location,type)
{
	var opt={};
	class_add(sw.search_limit,"hidden");
	if (!location) location=pref.search_default;
	var txt=sw.search_input.value;
#	Clear out any existing folder specification
	var srch=txt.split(' ');
	for(var i=0;i<srch.length;i++)
		if(srch[i]=='folders:single' || srch[i]=='folders:recent' || srch[i]=='folders:all')
			srch.splice(i,1);
# 	Specify the folders if required
	if(location!=pref.search_default) 
		srch.push('folders:'+location);
	txt=srch.join(' ');
	sw.search_input.value=txt;	
#	Now action it
	if(location!='single')
		opt.multiple=true;
	search_init(txt,type,location);
	action_search(sw.fld_id,0,false,false,true,opt)
}

function action_search(p1,p2,p3,p4,p5,p6)
{
	if(sw.search_type=='body'){
		x_confirm('"Body search" may take 30 seconds or more per 100 MB of mail that needs to be searched. <br><br>You are using a total of '+sw.quota.used+' on this account. <br>Do you want to continue?',function(n){
			if(!n)return;
			F(p1,p2,p3,p4,p5,p6);	
		});
		return;
	}
	F(p1,p2,p3,p4,p5,p6);	
}

function search_info(type,location)
{
	flds='recent';
	var sel='style="background:#888;"';
	if(!location) location='single';
	if (type=='quick'){
		info='<td>Quick search: </td>'
		+'<td><input type="button" value="Search whole / more folders" class="mnu_small" onclick="do_search_folders(undefined,\'folder\')"></td>';
	}else if(type=='folder'){
		var info='<td> Search: </td> '
		+'<td '+(location=='single'?sel:'')+'><input type="button" value="'+sw.fld_id+'" class="mnu_small" onclick="do_search_folders(\'single\',\'folder\')"></td>'
		+'<td '+(location=='recent'?sel:'')+'><input type="button" value="Recent folders" class="mnu_small" onclick="do_search_folders(\'recent\',\'folder\')"></td> '
		+'<td '+(location=='all'?sel:'')+'><input type="button" value="All folders" class="mnu_small" onclick="do_search_folders(\'all\',\'folder\')"></td>'
		+'<td><a href="#" class="mnu_small link_blue" onclick="do_search_save()">Save...</a><td>';
	}else{
		var sel='style="background:#888;"';
		var info='<td> Body search: </td> '
		+'<td '+(location=='single'?sel:'')+'><input type="button" value="'+sw.fld_id+'" class="mnu_small" onclick="do_search_folders(\'single\',\'body\')"></td>'
		+'<td '+(location=='recent'?sel:'')+'><input type="button" value="Recent folders" class="mnu_small" onclick="do_search_folders(\'recent\',\'body\')"></td> '
		+'<td '+(location=='all'?sel:'')+'><input type="button" value="All folders" class="mnu_small" onclick="do_search_folders(\'all\',\'body\')"></td>'
		+(location=='single'?'':'<td> <i>(May be slow)</i><td>');
	}
	sw.search_limit.innerHTML='<table><tr>'+info+'</tr></table> ';
	sw.search_location=location;
}


function show_thread(mid){
	if(sw.is_popup){
		return sw_win.show_thread(mid);
		return;
	}
	qmsg=sw_cache[cache_id(sw.fid,mid)];	
	var txt='subject:"'+qmsg.data['subject']+'"';
	if(pref.search_default!='recent') txt+=' folders:recent';
	var opt={};
	opt.multiple=true;
	search_init(txt);
	F(sw.fld_id,0,0,false,true,opt);
	return

	altlist = sw.active.childNodes[0];
	class_remove(altlist,'hidden');
	F2(sw.active.jmsg.fld_id, sw.active.jmsg.fld_type, sw.active.jmsg,'thread')	
}
function show_history(email){
	if(sw.is_popup){
		return sw_win.show_history(email);
		return;
	}
	var txt='email:'+email;
	if(pref.search_default!='recent') txt+=' folders:recent';
	var opt={};
	opt.multiple=true;
	search_init(txt);
	F(sw.fld_id,0,0,false,true,opt);
	return
		
	
	altlist = sw.active.childNodes[0];
	class_remove(altlist,'hidden');
	F2(sw.active.jmsg.fld_id, sw.active.jmsg.fld_type, sw.active.jmsg,'history')	
}
var altlist;

function do_search_save()
{
	var rule=sw.search_input.value;
	if(rule.indexOf('folders:')==-1) rule+=' folder:"'+sw.fld_id+'"';
	x_prompt('Save search:  (also known as "smart folder")<br><br><div class="smart_folder_rule">'+encode_lt_gt(rule)+'</div>','text description',function(val){
		if (!val) return;
		save_search(val,rule);
	});
}
function save_search(name,rule)
{
	var param='&saved_search_name='+xescape(name)+'&saved_search_rule='+xescape(rule);
	sndReq('cmd=save_search,show&'+param+'&page=~result.js', function(chan){
		success=actionReqJsStat(chan);
		if(success){
			set_status('Search saved',"success");
		}else{
			set_status('Search save failed ('+success_string+')','warning');
		}
	});
}

function delete_search(e,name)
{
	stopEvent(e);
	x_confirm('Are you sure you wish to delete the saved search: '+name, function(n){
		if(!n) return;
		save_search(name,'');
	});
}

var rcpt_contact;
function rcpt_mouseup(e)
{
	if(e.button!=2)return;
	var t=target(e);
	if(t && class_contains(t,'rcpt')){
		rcpt_contact=t;
		do_menu_show('context_menu_rcpt',e,undefined,undefined,{cursor:true})
		no_contextmenu_once=true;
	}
}
function rcpt_menu_contact(type)
{
	var t=rcpt_contact;
	var email=t.getAttribute('rcpt_addr');
	var name=t.getAttribute('rcpt_name');
	switch (type){
		case 'send': 
			contact_click_send(email,name); 
			break;
		case 'add': 
			contact_click_add(email,name); 
			break;
	}
}

function contact_click(e)
{
	var t=target(e);
	var email=t.getAttribute('rcpt_addr');
	var name=t.getAttribute('rcpt_name');
	contact_click_send(email,name); 
}

# cf: msg_list_click
function msg_list_mouseup(e)
{
	if(e.button!=2) return;

	var t=target(e);
	var tag=t.tagName.toLowerCase();
	var row=find_message_row(t);
	var td=find_message_td(t);
	if(td==row.childNodes[1]){
		no_contextmenu_once=true;
		return;
	}

	if(!class_contains(row,'selected')) {
		select_none_fast();
		row_select(row,true);
	}

	if(el_to_labels(t)){
		labels_cx(e);
	}else if(td==row.childNodes[0])
		do_menu_show('pg_menu_mark',e,undefined,undefined,{cursor:true})
	else
		do_menu_show('pg_menu_message',e,undefined,undefined,{cursor:true})
	e.xxx = 42; // *Q*
	dbg('*Q* msg_list_mouseup')
	
	no_contextmenu_once=true;
}

function folder_mouseup(e)
{
	if(e.button==2){
		t=target(e);
		var row=ancestor_by_tag(t,'li');
#		debugger
		id=row.getAttribute('fld_id');
		if(id && id.length>0 || class_contains(row,'fake')){
			sw.menu_fld=id;
			sw.menu_short=row.getAttribute('fld_short');
			cx_menu_init(row.getAttribute('fld_type'))
			do_menu_show('context_menu_folder',e,undefined,undefined,{cursor:true})
			no_contextmenu_once=true;
		}
	}
}

function cx_menu_init(type)
{
	m=[];
#	debugger;
	m.push('<a href="#" onmouseup="folder_create_cx()">Create new folder</a>');
	if(type==5&&type!=null) m.push('<a href="#" onmouseup="delete_folder(sw.menu_fld)">Delete folder</a>');
	if(type==5&&type!=null) m.push('<a href="#" onmouseup="rename_folder()">Rename folder</a>');
	if(type!=null)m.push('<a href="#" onmouseup="do_refresh2(\'folder\')">Refresh folder</a>');
	m.push('<a href="#"><hr></a>');
	m.push('<a href="#" onmouseup="do_refresh2(\'all\')">Refresh all folders</a>');
	mnu=dge('context_menu_folder')
	mnu.shadofied=false;
	mnu.innerHTML=m.join('');
}

function do_remind(sec)
{
	alert('remind in '+sec+' seconds - not yet implemented')
}

function do_refresh2(type)
{
	if(type=='folder')
		return F(sw.menu_fld,undefined,undefined,true,undefined,{refresh_allmsgs:true});

	x_confirm('This may take some time on large accounts.<br>Are you sure you want to do refresh all messages in all folders?', function(n){
		if(!n) return;
		set_status('Starting background update of all folders...','info');
		refresh_flds(true);
	});
}
#do_refresh2

function filtermenu_new(txt,txt2)
{
	return 	'<div class="filtermenu_search" onkeydown="stopBubble(event)" ><img src="||www_base||shared/img/1pixel.gif" class="search_icon mnu_filter" /><input type="text" class="filtermenu_input" onmouseup="stopBubble(event)" onkeyup="filtermenu_onkeyup(this,event)" onclick="stopEvent(event)"></div>'+
			'<div class="filtermenu_scrolling">'+txt+'</div>'+
			'<div>'+txt2+'</div>';
}
function menu_to_filter(el){
	return el.firstChild.childNodes[1];
}
function menu_to_ctl(el){
	return el.firstChild.childNodes[1];
}
function ctl_to_list(el){
	return el.parentNode.nextSibling.firstChild;
}
function list_to_menu(el){
	return ancestor_by_class(el,'xmenu');
}

function filtermenu_new_label(e)
{
	el=dge('label_menu');
	if(el.match_text && el.match_text) {
		do_label_set(el.match_text,true);
		return;
	}
	x_prompt('Name of the new label to create:','labelname',function(val){
		if (!val) return;
		do_label_set(val,true);
	});
}
function filtermenu_newitem(e,type)
{
	stopBubble(e);	
	var mnu=dge(type+'_menu');
	if(mnu.match_text && mnu.match_text) {
		filtermenu_action(mnu,mnu.match_text,true);
		return;
	}
	x_prompt('Name of the new '+type+':',type+'name',function(val){
		if (!val) return;
		filtermenu_action(mnu,val,true);
	});
}

function filtermenu_onkeyup(ctl,e)	// cf contact_search_do
{
	stopBubble(e);	
	t=target(e);
	var list=ctl_to_list(t);
	var x_list=list.getElementsByTagName('li');
	
	var mnu=list_to_menu(list);
	switch(e.keyCode){
#			up arrow 38
		case 38:
#			down arrow 40
		case 40:
#debugger;
			if(list.select_id==undefined) 
				list.select_id=-1;
			if(list.select_id>=0) 
				class_remove(x_list[list.select_id].firstChild,'selected');
			for(var count=x_list.length;count>0;count--){
				list.select_id+=(e.keyCode==40?1:-1);
				if (list.select_id<0) list.select_id=x_list.length-1;
				if (list.select_id>=x_list.length) list.select_id=0;
				if(!class_contains(x_list[list.select_id],'hidden'))
					break;
			}
			dbg('ZZZZ:'+list.select_id);
			if(count>0)
				class_add(x_list[list.select_id].firstChild,'selected')
			break;
# enter key			
		case 13:
			var id;
			dbg('DDDDD ENTER '+list.select_id)
			dbg('DDDDD ENTER '+mnu.menu_list.select_id)
			if(mnu.match_text && mnu.match_text.length>0){
				id=mnu.match_text;
				filtermenu_action(mnu,id,true)
			}else{
				id=x_list[list.select_id].getAttribute(mnu.search_attrib);
				filtermenu_action(mnu,id,false,mnu.del_menu)
			}
			menu_hide(mnu.id);
			filtermenu_search_clear(mnu.menu_list);
			break;
# escape
		case 27:
			dbg('DDDDD ESC '+list.select_id)
			dbg('DDDDD ESC '+mnu.menu_list.firstChild.select_id)
			menu_hide(mnu.id);
			filtermenu_search_clear(mnu.menu_list);
			break;
		default:
			setTimeout(function(){filtermenu_search_real(ctl)},10);
			break;

	}	
}
function filtermenu_search_real(ctl,unselect)
{
#	debugger;
	var match=ctl.value;
	var match_lwr=match.toLowerCase();
	var items=ctl_to_list(ctl);
	var mnu=list_to_menu(items);
#	Hide / show each row in the menu	
	var x_items=items.getElementsByTagName('li');
	for(var i=0;i<x_items.length;i++){
		row=x_items[i];
	
		var id=row.getAttribute(mnu.search_attrib);
		if(!id) {
	        class_add(row,"hidden");
			continue;
		}
		var ids=id.split('/');
		x=ids[ids.length-1].substring(0,match_lwr.length).toLowerCase();
        if(x==match_lwr){
            class_remove(row,"hidden");
            if(ids.length>0){
            	var el=row;
            	while(el.parentNode.tagName.toLowerCase()=='ul' && !(class_contains(el.parentNode,'ftree')||class_contains(el.parentNode,'ltree'))){
            		el=ancestor_by_tag(el.parentNode,'li');
					class_remove(el,"hidden");
					if(x.length>0 && class_contains(el,'closed')) fld_expand(undefined,undefined,el);
            	}
            }
            row.match=true;
        }else{
	        class_add(row,"hidden");
	        row.match=false;
        }
    }

# 	Remove any previous selection   
	dbg('filtermenu_search_real select_id='+items.select_id)
    if(items.select_id && items.select_id>=0){
    	if(!class_contains(x_items[items.select_id],'hidden')) return;
#		if(unselect || class_contains(x_items[items.select_id],'hidden'))
		class_remove(x_items[items.select_id].firstChild,'selected');
    }
#    if(unselect) items.select_id=-1;
    mnu.match_text='';

	if(mnu.create_item){
		mnu.create_item.innerHTML='New '+mnu.menu_type;
	}
#    var el=dge('label_menu_newlabel')
#    var el=dge('folder_menu_newfolder')
#    el.innerHTML='New Label';
#debugger;
	if(match.length==0) return;

#	Now select the first plausible match or allow new item to be created
#	var x_items=items.getElementsByTagName('li');
	var len=x_items.length;
	for(var count=0;count<=x_items.length;count++){
		if(count==len){
			count=-1;
			break;
		}
		row=x_items[count];
		if(!row.match) continue;
		if(!class_contains(row,'hidden'))
			break;
	}
	if (count>=0){
		items.select_id=count;
		class_add(x_items[count].firstChild,'selected');
    } else if(count==-1){
		if(mnu.create_item){
	    	mnu.create_item.innerHTML+=' "'+match+'"';
	    }
    	mnu.match_text=match;
    }
}
function filtermenu_search_clear(zlist)
{
#debugger;	
	var list=zlist.firstChild;
	dbg('QQQQ '+list.select_id);
	if (list.select_id==undefined) {
		list.select_id=-1;
		return;
	}
	if (list.select_id<0) return;
	var x_list=list.getElementsByTagName('li');
	dbg('QQQQ REMOVING SEL:'+list.select_id+'x_items.length'+x_list.length);
	class_remove(x_list[list.select_id].firstChild,'selected');
	list.select_id=-1;
}
function filtermenu_action(mnu,id,create_new)
{
	if (!mnu.cb) return;
	mnu.cb('ok',id,create_new,mnu.del_menu);
}
function do_label_menu(e,el) 
{
}
function ltree_mouseup(e)
{
	var t=target(e);
	var el=ancestor_by_class(t,'qlabel');
	var label=el.getAttribute('labelid');
	if(!label || label.length==0) return;
	var mnu=dge('label_menu');
	filtermenu_action(mnu,label);
}
//cf do_folder_menu & no ftree_mouseup 

# cf do_folder_create
function labels_create()
{
	var sw_label=dge('label_new_type').checked;
	sndReq('cmd=labels_manage,show&action=create&label_name='+xescape(dge('label_new_name').value)+'&sw_label='+sw_label+'&page=~labels.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
		if(!success) set_status(success_string,'warning');
	});
}
function labels_rename(tag,name)
{
	x_prompt('Rename the label "'+name+'" to:',name,function(val){
		if(!val) return;
		sndReq('cmd=labels_manage,show&action=rename&label_name='+xescape(tag)+'&label_name_dst='+xescape(val)+'&page=~labels.htm', function(chan){
			node=actionReqSethtml(chan.responseText,'utility');
			if(!success) set_status(success_string,'warning');
			else label_cache_reset();
		});
	});
}
function labels_show(label)
{
	sndReq('cmd=labels_manage,show&action=show&label_name='+xescape(label)+'&page=~labels.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
		if(!success) set_status(success_string,'warning');
		else label_cache_reset();
	});
}
function labels_hide(label)
{
	sndReq('cmd=labels_manage,show&action=hide&label_name='+xescape(label)+'&page=~labels.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
		if(!success) set_status(success_string,'warning');
		else label_cache_reset();
	});
}
function labels_clientmap_apply()
{
	sndReq('cmd=labels_manage,show&action=mapping&mail_client='+xescape(dge('labels_clientmap').value)+'&page=~labels.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
		if(!success) set_status(success_string,'warning');
	});
}

# WARNING: label cols now defined in editor_plain.js
function color_swatches(per_line)
{
	var txt='';
	for(var i=0;i<label_cols.length;i++){
  		if( i%per_line == 0 )txt += '<tr>'; 	
		txt+='<td class="swatch_hover"><div class="swatch" style="background:'+label_cols[i][0]+';border:1px solid '+label_cols[i][1]+';" pickid="'+i+'"></div>';
	}
	return txt;
}

function labels_color(e,label)
{
	var el=dge('picker_menu');
	el.innerHTML='<table onmouseup="label_color_select(event)">'+color_swatches(5,'labels')+'</table>';
	el.cur_item=label;
	do_menu_show('picker_menu',e,undefined,undefined,{cursor:true})
}
function label_color_select(e)
{
	var el=target(e);
	var picked=el.getAttribute('pickid');
	if(!picked) return;
	var el=dge('picker_menu');	
	sndReq('cmd=labels_manage,show&action=color&label_name='+xescape(el.cur_item)+'&color='+picked+'&page=~labels.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
		if(!success) set_status(success_string,'warning');
		else label_cache_reset();
	});
}
function label_cache_reset()
{
	cache_clear();
	sw.msglist_refresh=true;
}
function labels_done()
{
	window_manager_minimise(sw.active);
	window_manager_restore();	
}
function el_to_labels(el)
{
	return ancestor_by_class(el,'labels');
}
function do_label_cxmenu_setup(el)
{
	var txt='';
	txt+='<a href="#" onmousedown="do_label_clear(\'all\',true)">Remove all labels</a>'
	txt+='<i>&nbsp;Remove one label:</i>'
	for (var i=0;i<el.childNodes.length;i++){
		var id=el.childNodes[i].getAttribute('label_id');
		txt+='<a href="#" onmouseup="cx_label_remove(this,event)" label_id="'+id+'"> &nbsp;&nbsp;&nbsp;- '+id+'</a>';
	}
	txt+='<hr><a href="#" onclick="labels_menu(event,\'cx_menu\')">Add label...</a>'
	txt+='<hr><i>&nbsp;Show all with label:</i>'
	for (var i=0;i<el.childNodes.length;i++){
		var id=el.childNodes[i].getAttribute('label_id');
		txt+='<a href="#" onmouseup="cx_label_show(this,event)" label_id="'+id+'"> &nbsp;&nbsp;&nbsp;'+id+'</a>';
	}
	var mnu=dge('context_menu_label');
	mnu.innerHTML=txt;
	mnu.shadofied=false;	
}
function labels_cx(e)
{		  	
	var t=target(e);
	do_label_cxmenu_setup(el_to_labels(t))
	do_menu_show('context_menu_label',e,undefined,undefined,{cursor:true})
	no_contextmenu_once=true;
}		  	
function cx_label_remove(el,e)
{
	t=target(e);
	do_label_clear(el.getAttribute('label_id'));
}
function cx_label_show(el,e)
{
	var label=el.getAttribute('label_id');
	if(sw.is_popup) {
		sw_win.L(label);
	}else{
		L(label);
	}
}
function msgpanel_to_msglabels(el)
{
	return el.childNodes[1].childNodes[0].childNodes[1];
}

# cf n allow_images
function do_label_set(id,force,el)
{
	if(sw.is_popup){
		sw_win.do_label_set(id,force,dge('msg_headers').childNodes[1]);
		return;	
	}
	var sel=find_sel();
	if (!sel) return;

	if(class_contains(sw.active,'message')) 
		el=msgpanel_to_msglabels(sw.active.container.popup_message);

	ajax_label(sel,(force?'xset':'set'),id,function(node){},el)
}
function do_label_clear(id,all,el)
{
	if(sw.is_popup){
		sw_win.do_label_clear(id,all,dge('msg_headers').childNodes[1]);
		return;	
	}
	var sel=find_sel();
	if (!sel) return;

	if(class_contains(sw.active,'message')) 
		el=msgpanel_to_msglabels(sw.active.container.popup_message);

	ajax_label(sel,(all?'xclear':'clear'),id,function(node){},el)
}

function shadofy(o)
{
	var el;
	if(o.shadofied) return;
	var shadows=['top_left','top_edge','top_right','left_edge','right_edge','bottom_left','bottom_edge','bottom_right'];
	for(var i=0;i<shadows.length;i++){
		el=new_element(o,'div');
		class_add(el,shadows[i]);
		class_add(el,'shadow');
		el.onclick=function(){dbg("SHADOW onclick")};
	}
	o.shadofied=true;
}


# Preliminary stuff for the label / folder menus
function move_menu(e,source,ctl)
{
	do_folder_menu_setup(e,'folder_menu');
#	do_generic_menu_setup('folder','folder_menu',(e&&e.shiftKey));
	if(source=='button'){
		do_move_show(e)
	}else if(source=='more_actions'){
		do_move_show(e,ctl);
	}else if(source=='kbd'){
		do_move_show(e,dge('mnu_more'));
	}
}
function labels_menu(e,source,ctl)
{
	if(source=='button'){
		do_label_show(e);
	}else if(source=='more_actions'){
		do_label_show(e,ctl);
	}else if(source=='cx_menu'){
		setTimeout(function(){
			do_label_menu_setup(undefined,'label_menu');
			var el=dge('mnu_more');
			if(sw.is_popup || class_contains(sw.active,'message')) el=dge('menu_message_label');
			do_label_show(undefined,el);
		},5);
	}else if(source=='kbd'){
		do_label_show(e,dge('mnu_more'));
	}
}
function do_label_show(e,input)
{
	var options={};
	if(input) options.t=input;

	do_label_menu_setup(e,'label_menu');
	do_menu_show('label_menu',e,true,	function(result,id,create_new,del_menu){

		var sel=find_sel(true);
		if (!sel) return;

#		if(input) input.value='';
		filtermenu_search_clear(dge('label_menu').menu_list);
		msglist_select(sel[sel.length-1]);
		if(result!='ok'){
			return;	
		}

		if(del_menu)
			do_label_clear(id);
		else
			do_label_set(id,create_new);

#		if(sw.is_popup){
#			sw_win.do_move_popup(sw.mid,sw.fld_id,fld_id);
#			window.close();
#			return;
#		}
#		set_move_status(sel,fld_id);
#		dbg('do_move - selection ['+sel+']');
#		ajax_msg_move(sel,fld_id);
	}, options);
}


function mark_read(mid,delay,type)
{
	var el=document.getElementById('sel_'+mid);
	if (!el || !class_contains(sel_to_row(el),'msg_unread')) return;		

	if(delay){
		var sel=make_sel(sw.fld_id,mid);
		seen_timer=setTimeout(function(){set_seen(sel)},(type=='initial'?7000:2500));		
	}else{	
		ajax_set_flags(make_sel(sw.fld_id,cursor_mid),'set','seen',function(node){class_remove(node,'msg_unread')})
	}
}
function set_seen(sel){
	ajax_set_flags(sel,'set','seen',function(node){class_remove(node,'msg_unread')});
	seen_timer=null;
}

